(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: PRVOCIS.PAS                                                    *)
(*  Obsah: funkce pro rozklad cisel na soucin prvocinitelu + demo          *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 16.4.2008                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program prvocisla;

var cislo:word;
{$R-} {vypnuti kontroly rozsahu, aby program nespadl, pokud uzivatel zada
       neco, co se do vyse uvedene promenne nevejde}

function JePrvocislo(Cislo:word):boolean;
{Vraci true, pokud je zadane Cislo prvocislo. Pracuje metodou hrube sily.}
var j:word;
Begin
jeprvocislo:=true;
if cislo>3 then {cokoli <=3 je urcite prvocislo}
 for j:=2 to cislo shr 1 do {vyzkousime vsechny delitele od 2 do poloviny daneho cisla}
  if cislo mod j=0 then begin {pokud je timto cislem beze zbytku delitelne...}
                        jeprvocislo:=false; {...tak to neni prvocislo...}
                        break; {...a koncime}
                        end;
End;{jeprvocislo}

function NaStr(Cislo:word):string; {prevadi dane Cislo na retezec}
var vysl:string[5];
Begin
str(cislo,vysl);
nastr:=vysl;
End;{nastr}

function Prvocinitele(Cislo:word):string;
{Rozlozi dane Cislo na soucin prvocinitelu (napr. pro cislo=42 vrati '2*3*7').}
var cinitel:word;
    seznam:string; {sem se bude ukladat vysledek}
Begin
if cislo<=3 then seznam:=nastr(cislo) {az do trojky jsou to prvocisla, takze neni co resit}
            else begin
                 seznam:='';
                 cinitel:=2;
                  repeat
                  if jeprvocislo(cinitel) {zajimaji nas jen prvociselne cinitele}
                    then while (cislo mod cinitel)=0 {dokud je cislo timto cinitelem delitelne}
                           do begin
                              if seznam<>'' then seznam:=seznam+'*'; {pridame znamenko,}
                              seznam:=seznam+nastr(cinitel); {pripiseme cinitel}
                              cislo:=cislo div cinitel; {a cislo tim cinitelem vydelime}
                              end;
                  inc(cinitel);
                  until (cislo=1)or(cinitel>cislo); {dokud neprojdeme vsechny moznosti}
                 end;
prvocinitele:=seznam;
End;{prvocinitele}


BEGIN
writeln; writeln;
writeln(' Vita vas program pro blbnuti s prvocisly');
writeln('------------------------------------------');
 repeat
 write('Zadejte kladne cele cislo nebo nulu pro konec: ');
 readln(cislo);
 if jeprvocislo(cislo) then writeln('Cislo ',cislo,' je prvocislo.')
                       else begin
                            writeln('Cislo ',cislo,' neni prvocislo.');
                            writeln('Rozklad na prvocinitele: ',cislo,' = ',prvocinitele(cislo));
                            end;
 writeln;
 until cislo=0;
END.
